'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeEnv = require('../../nuke-env/lib/index.js');

var _nukeEnv2 = _interopRequireDefault(_nukeEnv);

var _nukeView = require('../../nuke-view/lib/index.js');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeRefreshControl = require('../../nuke-refresh-control/lib/index.js');

var _nukeRefreshControl2 = _interopRequireDefault(_nukeRefreshControl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WebPullToRefresh = void 0;
var isWeex = _nukeEnv2.default.isWeex,
    isWeb = _nukeEnv2.default.isWeb;


if (isWeb) {
    WebPullToRefresh = require('./mods/wptr.js');
}
var DEFAULT_END_REACHED_THRESHOLD = 500;
var DEFAULT_SCROLL_CALLBACK_THROTTLE = 50;
var FULL_WIDTH = 750;

var ScrollViewTest = function (_Component) {
    _inherits(ScrollViewTest, _Component);

    function ScrollViewTest(props) {
        _classCallCheck(this, ScrollViewTest);

        var _this = _possibleConstructorReturn(this, (ScrollViewTest.__proto__ || Object.getPrototypeOf(ScrollViewTest)).call(this, props));

        _this.lastScrollDistance = 0;
        _this.lastScrollContentSize = 0;
        _this.loadmoreretry = 1;

        _this.handleScroll = function (e) {
            if (isWeb) {
                if (_this.props.onScroll) {
                    e.nativeEvent = {
                        get contentOffset() {
                            return {
                                x: e.target.scrollLeft,
                                y: e.target.scrollTop
                            };
                        }
                    };
                    _this.props.onScroll(e);
                }

                if (_this.props.onEndReached) {
                    if (!_this.scrollerNode) {
                        _this.scrollerNode = (0, _rax.findDOMNode)(_this.refs.scroller);
                        _this.scrollerContentNode = (0, _rax.findDOMNode)(_this.refs.contentContainer);

                        _this.scrollerNodeSize = _this.props.horizontal ? _this.scrollerNode.offsetWidth : _this.scrollerNode.offsetHeight;
                    }

                    // NOTE：in iOS7/8 offsetHeight/Width is is inaccurate （ use scrollHeight/Width ）
                    var scrollContentSize = _this.props.horizontal ? _this.scrollerNode.scrollWidth : _this.scrollerNode.scrollHeight;
                    var scrollDistance = _this.props.horizontal ? _this.scrollerNode.scrollLeft : _this.scrollerNode.scrollTop;
                    var isEndReached = scrollContentSize - scrollDistance - _this.scrollerNodeSize < _this.props.onEndReachedThreshold;

                    var isScrollToEnd = scrollDistance > _this.lastScrollDistance;
                    var isLoadedMoreContent = scrollContentSize != _this.lastScrollContentSize;

                    if (isEndReached && isScrollToEnd && isLoadedMoreContent) {
                        _this.lastScrollContentSize = scrollContentSize;
                        _this.props.onEndReached(e);
                    }

                    _this.lastScrollDistance = scrollDistance;
                }
            }
            if (isWeex) {
                e.nativeEvent = {
                    contentOffset: {
                        // HACK: weex scroll event value is opposite of web
                        x: -e.contentOffset.x,
                        y: -e.contentOffset.y
                    }
                };
                _this.props.onScroll(e);
            }
        };

        _this.resetScroll = function () {
            if (isWeb) {
                _this.lastScrollContentSize = 0;
                _this.lastScrollDistance = 0;
            } else {
                _this.setState({
                    loadmoreretry: _this.loadmoreretry++
                });
            }
        };

        _this.scrollTo = function (options) {
            var x = parseInt(options.x);
            var y = parseInt(options.y);

            if (isWeex) {
                var dom = require('@weex-module/dom');
                var contentContainer = (0, _rax.findDOMNode)(_this.refs.contentContainer);
                dom.scrollToElement(contentContainer.ref, {
                    offset: x || y || 0
                });
            } else {
                var pixelRatio = document.documentElement.clientWidth / FULL_WIDTH;

                if (x >= 0) {
                    (0, _rax.findDOMNode)(_this.refs.scroller).scrollLeft = pixelRatio * x;
                }

                if (y >= 0) {
                    (0, _rax.findDOMNode)(_this.refs.scroller).scrollTop = pixelRatio * y;
                }
            }
        };

        _this.handleRefresh = function () {
            return new Promise(function (resolve, reject) {
                _this.onRefresh && _this.onRefresh(resolve, reject);
            });
        };

        _this.resetLoadmore = function () {
            if (isWeex) {
                _this.refs.scroller.resetLoadmore();
            }
        };

        _this.state = {
            loadmoreretry: 0,
            initializedWptr: false
        };
        _this.onRefresh = null;
        return _this;
    }

    _createClass(ScrollViewTest, [{
        key: 'initWeb',
        value: function initWeb() {
            if (isWeb && !this.state.initializedWptr) {
                WebPullToRefresh().init({
                    bodyEl: this.refs.scroller,
                    ptrEl: this.refs.refreshX,
                    contentEl: this.refs.contentContainer,
                    distanceToRefresh: this.props.distanceToRefresh || undefined,
                    loadingFunction: this.handleRefresh,
                    resistance: this.props.resistance || undefined,
                    hammerOptions: this.props.hammerOptions || { touchAction: 'auto' }
                });
                this.setState({
                    initializedWptr: true
                });
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (!this.props.disabledPtr) {
                this.initWeb();
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            if (!this.props.disabledPtr) {
                this.initWeb();
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                id = _props.id,
                style = _props.style,
                scrollEventThrottle = _props.scrollEventThrottle,
                showsHorizontalScrollIndicator = _props.showsHorizontalScrollIndicator,
                showsVerticalScrollIndicator = _props.showsVerticalScrollIndicator,
                onEndReached = _props.onEndReached,
                onEndReachedThreshold = _props.onEndReachedThreshold,
                onScroll = _props.onScroll,
                children = _props.children;

            // In weex must be int value

            onEndReachedThreshold = parseInt(onEndReachedThreshold, 10);

            var contentContainerStyle = [this.props.horizontal && styles.contentContainerHorizontal, this.props.contentContainerStyle];

            // bugfix: fix scrollview flex in ios 78
            if (!isWeex && !this.props.horizontal) {
                contentContainerStyle.push(styles.containerWebStyle);
            }

            if (this.props.style) {
                var childLayoutProps = ['alignItems', 'justifyContent'].filter(function (prop) {
                    return _this2.props.style[prop] !== undefined;
                });

                if (childLayoutProps.length !== 0) {}
            }

            var refreshContainer = _rax.createElement(_nukeView2.default, null),
                contentChild = void 0;
            if (Array.isArray(children)) {
                contentChild = children.map(function (child, index) {
                    if (child && child.type == _nukeRefreshControl2.default) {
                        refreshContainer = child;
                        _this2.onRefresh = child.props.onRefresh;
                    } else {
                        return child;
                    }
                });
            } else {
                contentChild = children;
            }

            var contentContainer = _rax.createElement(
                _nukeView2.default,
                {
                    ref: 'contentContainer',
                    style: contentContainerStyle },
                contentChild
            );

            var baseStyle = this.props.horizontal ? styles.baseHorizontal : styles.baseVertical;

            var scrollerStyle = _extends({}, baseStyle, this.props.style);

            var showsScrollIndicator = this.props.horizontal ? showsHorizontalScrollIndicator : showsVerticalScrollIndicator;

            if (isWeex) {
                return _rax.createElement(
                    'scroller',
                    _extends({}, this.props, {
                        ref: 'scroller',
                        style: scrollerStyle,
                        showScrollbar: showsScrollIndicator,
                        onLoadmore: onEndReached,
                        onScroll: onScroll ? this.handleScroll : null,
                        loadmoreoffset: onEndReachedThreshold,
                        loadmoreretry: this.state.loadmoreretry,
                        scrollDirection: this.props.horizontal ? 'horizontal' : 'vertical'
                    }),
                    refreshContainer,
                    contentContainer
                );
            } else {
                var _Object$assign;

                var handleScroll = this.handleScroll;
                if (scrollEventThrottle) {
                    handleScroll = throttle(handleScroll, scrollEventThrottle);
                }

                if (!showsScrollIndicator && !document.getElementById('rax-scrollview-style')) {
                    var styleNode = document.createElement('style');
                    styleNode.id = 'rax-scrollview-style';
                    document.head.appendChild(styleNode);
                    styleNode.innerHTML = '.' + this.props.className + '::-webkit-scrollbar{display: none;}';
                }

                scrollerStyle.webkitOverflowScrolling = 'touch';
                scrollerStyle.overflow = 'scroll';

                var webProps = _extends({}, this.props, {
                    ref: 'scroller',
                    style: scrollerStyle,
                    onScroll: handleScroll
                });
                delete webProps.onEndReachedThreshold;
                if (this.props.disabledPtr) {
                    return _rax.createElement(
                        _nukeView2.default,
                        webProps,
                        contentContainer
                    );
                }
                return _rax.createElement(
                    _nukeView2.default,
                    webProps,
                    (0, _rax.cloneElement)(refreshContainer, {
                        ref: "refreshX",
                        className: "ptr-element",
                        style: Object.assign((_Object$assign = { position: 'absolute', top: 0, left: 0, width: 750, color: '#aaaaaa' }, _defineProperty(_Object$assign, 'z-index', 10), _defineProperty(_Object$assign, 'textAlign', 'center'), _Object$assign), refreshContainer.props.style)
                    }),
                    contentContainer
                );
            }
        }
    }]);

    return ScrollViewTest;
}(_rax.Component);

ScrollViewTest.defaultProps = {
    scrollEventThrottle: DEFAULT_SCROLL_CALLBACK_THROTTLE,
    onEndReachedThreshold: DEFAULT_END_REACHED_THRESHOLD,
    showsHorizontalScrollIndicator: true,
    showsVerticalScrollIndicator: true,
    className: 'rax-scrollview'
};


function throttle(func, wait) {
    var ctx, args, rtn, timeoutID;
    var last = 0;

    function call() {
        timeoutID = 0;
        last = +new Date();
        rtn = func.apply(ctx, args);
        ctx = null;
        args = null;
    }

    return function throttled() {
        ctx = this;
        args = arguments;
        var delta = new Date() - last;
        if (!timeoutID) if (delta >= wait) call();else timeoutID = setTimeout(call, wait - delta);
        return rtn;
    };
}

var styles = {
    baseVertical: {
        flex: 1,
        flexDirection: 'column'
    },
    baseHorizontal: {
        flex: 1,
        flexDirection: 'row'
    },
    contentContainerHorizontal: {
        flexDirection: 'row'
    },
    containerWebStyle: {
        display: 'block'
    }
};

exports.default = ScrollViewTest;
module.exports = exports['default'];